class Game {
    width = 0
    height = 0
    htmlParent = null
    gameObjects = []


    constructor(width, height, htmlParent) {
        this.width = width
        this.height = height
        this.htmlParent = htmlParent

        for (let y = 0; y < this.height; y++) {
            let row = document.createElement('tr')
            for (let x = 0; x < this.height; x++) {
                let cell = document.createElement('td')
                cell.id = `cell-${x}-${y}`
                cell.class = 'cell'
                row.appendChild(cell)
            }
            this.htmlParent.appendChild(row)
        }

        // todo: setInterval na gameTick
    }

    /*
     Funkce kterou podstrcime hadovi, aby se mohl vykreslit
     */
    drawElement(x, y, color) {
        const cell = document.getElementById(`cell-${x}-${y}`)
        cell.style.background = color
    }

    addGameObject(gameObject){
        if(this.gameObjects.includes(gameObject)){
            throw new Error('object already added')
        }
        this.gameObjects.push(gameObject)
    }

    step() {
        // Zavolej vsem objektum gameTick
        for(const object of this.gameObjects){
            object.step()
        }
    }
    render() {
        // Smaz vsechno
        for (let y = 0; y < this.height; y++) {
            for (let x = 0; x < this.height; x++) {
                this.drawElement(x, y, 'white')
            }
        }
        // Vykresli vsechny objekty znovu
        for (const object of this.gameObjects) {
            object.draw(this.drawElement)
        }
    }

    stepAndRender(){
        this.step()
        this.render()
    }
}
